function [ PP, fs_var]=test_MTL_EP(x,X,Y,KGS,Kf,hyper_x,niHat,...
    tafHat,Shat,SHatH,L,zitatest,t,t_pointer,...
    DataCov)
% function to compute posterior class probabilities  for class "+1" 
% for each of the tasks, as well as the variance of the test latent function.
% PP     : row vector of posterior class probabilities 
% fs_var : row vector of variances of the latents.

[dim,m]  =  size(x);


for k=1:m
    
    a  =  x(:,k);

    kx    =  feval(DataCov,a,X,hyper_x);
    kstar =  feval(DataCov,a,a,hyper_x);
  
    Km     =  sparGPMTL(Kf,kx,t,t_pointer);
    Kmstar =  sparGPMTL(Kf,kstar,t,t_pointer);
    
    fs_mean  =  Km'*(niHat-zitatest);
    
    for i = 1:length(Kmstar)    
        ni  =  L'\(SHatH*Km(:,i));
        
        fs_var(k,i) = Kmstar(i)-ni'*ni;
        
        PP(k,i)=feval('cumGauss', [], fs_mean(i), fs_var(k,i)); 
    
    end
    
end

