function [niHat,tafHat,logZep,K,Shat,SHatH,L,zitatest,mi]=GPBC_EP_MF(X,Y,hyper,DataCov)
% Mode finding for MTL with EP approximation.
% Implementation follows algorithm described in Gaussian Processes for
% Machine learning

% cumGauss.m , solve_chol.m : functions taken from Rasmussen's implementation
% for GPs to obtain numerical stability.


[D,N]    =  size(X);
iter     =  15;
noise    =  1e-9;

niHat    =  zeros(N,1);
tafHat   =  zeros(N,1);
tafMinus =  zeros(N,1);
miMinus  =  zeros(N,1);
mi       =  zeros(1,N);

K     =  feval(DataCov,X,X,hyper)+noise*eye(N);
Sigma =  K;
logZep= zeros(iter,1);
for k = 1:iter
    
    
    for i = 1:N
        tafMinus(i)    =   (1/Sigma(i,i))-tafHat(i);
        niMinus(i)     =   (mi(i)/Sigma(i,i))-niHat(i);
        miMinus(i)     =   niMinus(i)/tafMinus(i);
        

        [m0, m1, m2]   =   feval('cumGauss', Y(i), niMinus(i)/tafMinus(i), 1/tafMinus(i));
        
        hmu   =   m1./m0;
        hs2   =   m2./m0 - hmu^2;     
        
        %%Update Site Parameters
        
        Deltataf(i)   =   (1/hs2)-tafMinus(i)-tafHat(i);
        tafHat(i)     =   tafHat(i)+Deltataf(i);
         
        niHat(i)      =   (hmu/hs2)-niMinus(i);
        ff            =   1/((1/Deltataf(i))+Sigma(i,i));
        gg            =   Sigma(:,i)*Sigma(:,i)';
        Sigma         =   Sigma-ff*gg;      
        mi            =   Sigma*niHat;
    end
   
    Shat   =   diag(tafHat);
    
    sW     =   sqrt(tafHat);
    
    B      =   eye(N)+sW*sW'.*K;
        
    L      =   chol(B);
    
    V      =   L'\(repmat(sW,1,N).*K);
    
    Sigma  =   K-V'*V;
    
    mi     =   Sigma*niHat;
    
   
    SHatH    =  diag(sW);

    TT       =  ones(length(tafHat),1)+tafHat.*(tafMinus.^-1);

    Fi       =  cumGauss(Y,miMinus,tafMinus.^-1);

    logZep(k)=  0.5*sum(log(TT))-sum(log(diag(L)))+0.5*niHat'*...
        (K-K*SHatH*inv(B)*SHatH*K-(inv(diag(tafMinus)+Shat)))...
        *niHat+0.5*miMinus'*diag(tafMinus)*...
        inv(Shat+diag(tafMinus))*(Shat*miMinus-2*niHat)+sum(log(Fi)); 
    
    
end

zitatest =  sW.*solve_chol(L,sW.*(K*niHat));